#pragma once
#include <easy2d/e2dbase.h>

namespace easy2d
{


// 
class Random
{
public:
	// ȡ÷Χڵһ
	template<typename T>
	static inline T range(T min, T max) 
	{ 
		return easy2d::Random::__randomInt(min, max); 
	}

	// ȡ÷Χڵһ
	static inline float range(float min, float max) 
	{ 
		return easy2d::Random::__randomReal(min, max); 
	}

	// ȡ÷Χڵһ
	static inline double range(double min, double max)
	{ 
		return easy2d::Random::__randomReal(min, max); 
	}

private:
	template<typename T>
	static T __randomInt(T min, T max)
	{
		std::uniform_int_distribution<T> dist(min, max);
		return dist(Random::__getEngine());
	}

	template<typename T>
	static T __randomReal(T min, T max)
	{
		std::uniform_real_distribution<T> dist(min, max);
		return dist(Random::__getEngine());
	}

	// ȡ
	static std::default_random_engine &__getEngine();
};


// 
class Music :
	public Object
{
	friend class Game;

public:
	Music();

	explicit Music(
		const String& filePath		/* ļ· */
	);

	Music(
		int resNameId,				/* Դ */
		const String& resType		/* Դ */
	);

	virtual ~Music();

	// ļ
	bool open(
		const String& filePath		/* ļ· */
	);

	// Դ
	bool open(
		int resNameId,				/* Դ */
		const String& resType		/* Դ */
	);

	// 
	bool play(
		int nLoopCount = 0
	);

	// ͣ
	void pause();

	// 
	void resume();

	// ֹͣ
	void stop();

	// رղԴ
	void close();

	// Ƿڲ
	bool isPlaying() const;

	// 
	bool setVolume(
		float volume
	);

private:
	static bool __init();

	static void __uninit();

private:
	class Media;
	Media* _media;
};


// ֲ
class MusicPlayer
{
	friend class Game;

public:
	// ԤԴ
	static Music* preload(
		const String& filePath	/* ļ· */
	);

	// 
	static bool play(
		const String& filePath,	/* ļ· */
		int nLoopCount = 0		/* ظŴ -1 Ϊѭ */
	);

	// ͣ
	static void pause(
		const String& filePath	/* ļ· */
	);

	// 
	static void resume(
		const String& filePath	/* ļ· */
	);

	// ֹͣ
	static void stop(
		const String& filePath	/* ļ· */
	);

	// ȡֲ״̬
	static bool isPlaying(
		const String& filePath	/* ļ· */
	);

	// ԤԴ
	static Music* preload(
		int resNameId,			/* Դ */
		const String& resType	/* Դ */
	);

	// 
	static bool play(
		int resNameId,			/* Դ */
		const String& resType,	/* Դ */
		int nLoopCount = 0		/* ظŴ -1 Ϊѭ */
	);

	// ͣ
	static void pause(
		int resNameId,			/* Դ */
		const String& resType	/* Դ */
	);

	// 
	static void resume(
		int resNameId,			/* Դ */
		const String& resType	/* Դ */
	);

	// ֹͣ
	static void stop(
		int resNameId,			/* Դ */
		const String& resType	/* Դ */
	);

	// ȡֲ״̬
	static bool isPlaying(
		int resNameId,			/* Դ */
		const String& resType	/* Դ */
	);

	// ȡ
	static float getVolume();

	// 
	static void setVolume(
		float volume			/* ΧΪ -224 ~ 2240 Ǿ1  */
	);

	// ͣ
	static void pauseAll();

	// 
	static void resumeAll();

	// ֹͣ
	static void stopAll();

private:
	static void __uninit();
};


// ʱ
class Timer
{
	friend class Game;

public:
	// Ӷʱÿִ֡һΣ
	static void add(
		const Function<void()>& func,	/* ִк */
		const String& name = L""		/* ʱ */
	);

	// Ӷʱ
	static void add(
		const Function<void()>& func,	/* ִк */
		float delay,					/* ʱ룩 */
		int times = -1,					/* ִд -1 ΪִУ */
		bool paused = false,			/* Ƿͣ */
		const String& name = L""		/* ʱ */
	);

	// 㹻ӳٺִָ
	static void start(
		float timeout,					/* ȴʱ룩 */
		const Function<void()>& func	/* ִеĺ */
	);

	// ͬƵĶʱ
	static void start(
		const String& name
	);

	// ֹͣͬƵĶʱ
	static void stop(
		const String& name
	);

	// ƳͬƵĶʱ
	static void remove(
		const String& name
	);

	// жʱ
	static void startAll();

	// ֹͣжʱ
	static void stopAll();

	// Ƴжʱ
	static void removeAll();

private:
	// ¶ʱ
	static void __update();

	// öʱ״̬
	static void __resetAll();

	// նʱ
	static void __uninit();
};


// ݹ
class Data
{
public:
	//  int ͵ֵ
	static void saveInt(
		const String& key,					/* ֵ */
		int value,							/*  */
		const String& field = L"Defalut"	/* ֶ */
	);

	//  float ͵ֵ
	static void saveDouble(
		const String& key,					/* ֵ */
		float value,						/*  */
		const String& field = L"Defalut"	/* ֶ */
	);

	//  bool ͵ֵ
	static void saveBool(
		const String& key,					/* ֵ */
		bool value,							/*  */
		const String& field = L"Defalut"	/* ֶ */
	);

	//  ַ ͵ֵ
	static void saveString(
		const String& key,					/* ֵ */
		const String& value,				/*  */
		const String& field = L"Defalut"	/* ֶ */
	);

	// ȡ int ͵ֵ
	// 򷵻 defaultValue ֵ
	static int getInt(
		const String& key,					/* ֵ */
		int defaultValue,					/* Ĭֵ */
		const String& field = L"Defalut"	/* ֶ */
	);

	// ȡ float ͵ֵ
	// 򷵻 defaultValue ֵ
	static float getDouble(
		const String& key,					/* ֵ */
		float defaultValue,				/* Ĭֵ */
		const String& field = L"Defalut"	/* ֶ */
	);

	// ȡ bool ͵ֵ
	// 򷵻 defaultValue ֵ
	static bool getBool(
		const String& key,					/* ֵ */
		bool defaultValue,					/* Ĭֵ */
		const String& field = L"Defalut"	/* ֶ */
	);

	// ȡ ַ ͵ֵ
	// 򷵻 defaultValue ֵ
	static String getString(
		const String& key,					/* ֵ */
		const String& defaultValue,			/* Ĭֵ */
		const String& field = L"Defalut"	/* ֶ */
	);
};


// ·
class Path
{
	friend class Game;

public:
	// ·
	static void add(
		String path
	);

	// ļ·
	static String searchForFile(
		const String& path
	);

	// ȡԴļȡļ·
	static String extractResource(
		int resNameId,				/* Դ */
		const String& resType,		/* Դ */
		const String& destFileName	/* Ŀļ */
	);

	// ȡݵĬϱ·
	static String getDataSavePath();

	// ȡʱļĿ¼
	static String getTempPath();

	// ȡִгľ·
	static String getExecutableFilePath();

	// 򿪱ļԻ
	static String getSaveFilePath(
		const String& title = L"浽",		/* Ի */
		const String& defExt = L""			/* Ĭչ */
	);

	// ļ
	static bool createFolder(
		const String& dirPath	/* ļ· */
	);

	// жļļǷ
	static bool exists(
		const String& dirPath	/* ļ· */
	);

private:
	// ʼ
	static bool __init(
		const String& gameName
	);
};

}